/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.esquemaoperacional;

import com.rjconsultores.ventaboletos.entidad.Via;
import com.rjconsultores.ventaboletos.service.ViaService;
import com.rjconsultores.ventaboletos.utilerias.RegistroConDependenciaException;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import java.util.Calendar;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.util.Clients;
import org.zkoss.zul.Button;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Administrador
 */
@Controller("editarViaController")
@Scope("prototype")
public class EditarViaController extends MyGenericForwardComposer {

    @Autowired
    private ViaService viaService;
    private Via via;
    private MyListbox viaList;
    private Textbox txtNome;
    private Button btnApagar;
    private static Logger log = Logger.getLogger(EditarViaController.class);

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    public Via getVia() {
        return via;
    }

    public void setVia(Via via) {
        this.via = via;
    }

    public Textbox getTxtNome() {
        return txtNome;
    }

    public void setTxtNome(Textbox txtNome) {
        this.txtNome = txtNome;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        via = (Via) Executions.getCurrent().getArg().get("via");
        viaList = (MyListbox) Executions.getCurrent().getArg().get("viaList");

        if (via.getViaId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        }

        txtNome.focus();
    }

    public void onClick$btnSalvar(Event ev) {
        txtNome.getValue();

        try {
            via.setActivo(Boolean.TRUE);
            via.setFecmodif(Calendar.getInstance().getTime());
            via.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());

            List<Via> lsVias = viaService.buscar(via.getNombvia());

            if (!lsVias.isEmpty()) {
                Messagebox.show(
                        Labels.getLabel("MSG.Registro.Existe"),
                        Labels.getLabel("editarViaController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
            } else {
                if (via.getViaId() == null) {
                    viaService.suscribir(via);
                    viaList.addItem(via);
                } else {
                    viaService.actualizacion(via);
                    viaList.updateItem(via);
                }

                Messagebox.show(
                        Labels.getLabel("editarViaController.MSG.suscribirOK"),
                        Labels.getLabel("editarViaController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }

    public void onClick$btnApagar(Event ev) {
        try {
            int resp = Messagebox.show(
                    Labels.getLabel("editarViaController.MSG.borrarPergunta"),
                    Labels.getLabel("editarViaController.window.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp == Messagebox.YES) {
                viaService.borrar(via);

                Messagebox.show(
                        Labels.getLabel("editarViaController.MSG.borrarOK"),
                        Labels.getLabel("editarViaController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                viaList.removeItem(via);

                closeWindow();
            }
        } catch (RegistroConDependenciaException ex) {
            Clients.alert(ex.getLocalizedMessage(),
                    Labels.getLabel("editarViaController.window.title"),
                    Messagebox.INFORMATION);
        } catch (Exception ex) {
            log.error(ex);
            Clients.alert(Labels.getLabel("MSG.Error"),
                    Labels.getLabel("editarViaController.window.title"),
                    Messagebox.INFORMATION);
        }
    }
}
